import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import { makeEntity } from 'react-entities';
import PropTypes from 'prop-types';
import initialStateFromSchema from './initialStateFromSchema';
import { extractPropTypes } from './types';
export var makeEntityWithSchema = function makeEntityWithSchema(_ref, deps) {
  var initialState = _ref.initialState,
      schema = _ref.schema,
      _ref$name = _ref.name,
      name = _ref$name === void 0 ? 'entity' : _ref$name,
      actions = _objectWithoutPropertiesLoose(_ref, ["initialState", "schema", "name"]);

  if (typeof schema !== 'object') throw new Error('Schema expected for entity.');
  var options = {};

  if (process.env.NODE_ENV !== 'production') {
    var strictSchema = {
      state: PropTypes.exact(extractPropTypes(schema))
    };

    var validatePropTypes = function validatePropTypes(currentState, updates) {
      var newState = _extends({}, currentState, updates);

      PropTypes.checkPropTypes(strictSchema, {
        state: newState
      }, 'entity state', name);
    };

    options.beforeSetState = validatePropTypes; // Also validate the provided initial state (if any)

    if (initialState) validatePropTypes({}, initialState);
  }

  return makeEntity(_extends({
    initialState: initialState || initialStateFromSchema(schema),
    options: options
  }, actions), deps);
};
export default makeEntityWithSchema;