"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = exports.makeEntityWithSchema = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _reactEntities = require("react-entities");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _initialStateFromSchema = _interopRequireDefault(require("./initialStateFromSchema"));

var _types = require("./types");

var makeEntityWithSchema = function makeEntityWithSchema(_ref, deps) {
  var initialState = _ref.initialState,
      schema = _ref.schema,
      _ref$name = _ref.name,
      name = _ref$name === void 0 ? 'entity' : _ref$name,
      actions = (0, _objectWithoutPropertiesLoose2["default"])(_ref, ["initialState", "schema", "name"]);
  if (typeof schema !== 'object') throw new Error('Schema expected for entity.');
  var options = {};

  if (process.env.NODE_ENV !== 'production') {
    var strictSchema = {
      state: _propTypes["default"].exact((0, _types.extractPropTypes)(schema))
    };

    var validatePropTypes = function validatePropTypes(currentState, updates) {
      var newState = (0, _extends2["default"])({}, currentState, updates);

      _propTypes["default"].checkPropTypes(strictSchema, {
        state: newState
      }, 'entity state', name);
    };

    options.beforeSetState = validatePropTypes; // Also validate the provided initial state (if any)

    if (initialState) validatePropTypes({}, initialState);
  }

  return (0, _reactEntities.makeEntity)((0, _extends2["default"])({
    initialState: initialState || (0, _initialStateFromSchema["default"])(schema),
    options: options
  }, actions), deps);
};

exports.makeEntityWithSchema = makeEntityWithSchema;
var _default = makeEntityWithSchema;
exports["default"] = _default;